<template>
  <q-date
    v-model="selectedDate"
    color="secondary"
    :default-year-month="rosterMonth"
    :events="eventDates"
    :title="rosterMonth"
    subtitle="選擇目標月份"
    :event-color="handleEventColor"
    @navigation="handleNavigation"
  >
    <slot />
  </q-date>
</template>


<script lang='ts' setup>
import { computed, ref, watch } from 'vue';
import dayjs from 'dayjs';
import { ClassSchedule } from '../../types/main.type';

import { useQuasar } from 'quasar';
import { useMainStore } from '../../store/main.store';

interface OnNavigationParams {
  year: number;
  month: number;
}

interface Props {
  classSchedule?: ClassSchedule;
}

const props = withDefaults(defineProps<Props>(), {
  classSchedule: undefined,
});

const emit = defineEmits<{
  (e: 'update:selectedDate', value: string): void;
  (e: 'update:rosterMonth', value: string): void;
}>();

const $q = useQuasar();
const store = useMainStore();

const dayItineraries = computed(() => store.dayItineraries);

/** 已選擇的日期 */
const selectedDate = ref('');
watch(selectedDate, (val) => {
  emit('update:selectedDate', val);
});

/** 班表月份。YYYY/MM */
const rosterMonth = ref(dayjs().format('YYYY/MM'));

const handleNavigation = ({ year, month }: OnNavigationParams) => {
  const mm = `${month}`.padStart(2, '0');
  rosterMonth.value = `${year}/${mm}`;
};
watch(rosterMonth, (val) => {
  emit('update:rosterMonth', val);
});

const eventDatesColor = computed(() => {
  if (!props.classSchedule) {
    return dayItineraries.value.map((dayItinerary) => {
      return {
        date: dayItinerary.date,
        color: 'light-blue',
      };
    });
  }

  return props.classSchedule.itineraries.map((dayItinerary) => {
    const hasEmpty = dayItinerary.vacancies.some(
      (vacancy) => !vacancy.executor
    );

    return {
      date: dayItinerary.date,
      color: hasEmpty ? 'red' : 'positive',
    };
  });
});

const eventDates = computed(() => {
  return eventDatesColor.value.map(({ date }) => date);
});
const handleEventColor = (date: string) => {
  const dateColor = eventDatesColor.value.find((item) => item.date === date);
  return dateColor?.color ?? 'red';
};
</script>
